// FileSystemJava.js
// Java file system implemetation

// Open file
function File(path)
{   
    var file = new java.io.File(path);            

    return file;    
}

// Create a folder
function CreateFolder(path)
{ 
    this.result=false;
    this.filePath = new java.io.File(path);
                 
    if (!this.filePath.exists()) {
        // create folder if it does not already exist
        // NOTE: Parent directory must exist
        this.result = this.filePath.mkdir();
    }
    
    return this.result;
}

// Delete a file or folder
function Delete(path)
{ 
    this.result=false;
    this.filePath = new java.io.File(path);
      
    if (this.filePath.exists()) {            
        this.result = this.filePath['delete'](); // 'delete' is a reserved word in Javascript           
    }
    
    return this.result;
}

// Check to see existence of a file or folder
function Exists(path)
{
    this.result=false; 
    this.filePath = new java.io.File(path);
      
    this.result = this.filePath.exists();            

    return this.result;
}

// Rename a file
function RenameFile(path, newName)
{
    this.result=false; 
    this.filePath = new java.io.File(path);
      
    if (this.filePath.exists()) {            
        this.result = this.filePath.renameTo(newName);          
    }
    
    return this.result;
}

// Open file to write to
function FileWriterOpen(path, attr)
{     
    if (attr) {
        file = new java.io.FileWriter(path, true); 
        return file;
    }     
    else {
        file = new java.io.FileWriter(path, false); 
        return file;
    }
}

// Open file to read from
function FileReaderOpen(path, attr)
{   
    var file = new java.io.FileReader(path);            

    if (attr) {
        fileBR = new java.io.BufferedReader(file);
        return fileBR;
    }     
    else {
        return file;
    }
}

// Close file
function FileClose(file)
{            
    file.close();
}

// Write to file
function Write(file, string)
{            
    file.write(string);
}

// read line
function ReadLine(file)
{            
    var string = file.readLine();
    
    return string;
}

// read all lines
function ReadAll(fileReader)
{            
    var fileRL;
    var fileReadData="";
    
    while ((fileRL = fileReader.readLine()) )        
    {            
        fileReadData = fileReadData + fileRL + "\n";
    }
    
    return fileReadData;
}

// return length of file
function Length(path)
{            
    this.filePath = new java.io.File(path);

    var fileLength = this.filePath.length();
    
    return fileLength;
}

// 
function GetAbsolutePath(path)
{            
    this.filePath = new java.io.File(path);

    var path = this.filePath.getParent();
    
    return path;
}

// strip full path off file name
function GetName(path)
{            
    this.filePath = new java.io.File(path);

    var name = this.filePath.getName();
    
    return name;
}


// Constructor for file system access
function FileSystem()
{
    // initialize object properties
    this.result=false;
    this.filePath;
    
    // methods for the object
    this.file = File;
    this.createFolder = CreateFolder;
    this.deletePath = Delete;
    this.exists = Exists;
    this.renameFile = RenameFile;
    this.fileWriterOpen = FileWriterOpen;
    this.fileReaderOpen = FileReaderOpen;
    this.fileClose = FileClose;
    this.write = Write;
    this.readLine = ReadLine;
    this.readAll = ReadAll;
    this.length = Length;
    this.getAbsolutePath = GetAbsolutePath;
    this.getName = GetName;
}

