// RuntimeJava.js
// Java runtime implemetation

function streams(proc)
{
    var stdin = proc.getInputStream();
    var isr = new java.io.InputStreamReader(stdin);
    var br = new java.io.BufferedReader(isr);
    var line = null;

    while ( (line = br.readLine()) != null)
        print("> " + line);           
}

// Synchronous run
function RunSynch(cmd)
{ 
    var rt = new java.lang.Runtime.getRuntime();
    
    print("> " + cmd);
    
    var proc = rt.exec(cmd);              

    streams(proc);

    var exitVal = proc.waitFor();
    
    return exitVal;
}

// Asynchronous run
function RunAsynch(cmd)
{ 
    var rt = new java.lang.Runtime.getRuntime();
    
    print("> " + cmd);
    
    var proc = rt.exec(cmd); 
    
    streams(proc);             
       
    //return exitVal;
}

// Constructor for file system access
function Runtime()
{
    this.runSynch = RunSynch;
    this.runAsynch = RunAsynch;
}

